package Game
{
	public class PowerUp
	{
		public var game:GameScene;
		public var active:Boolean;
		public var fading:Boolean;
		public var x:Number;
		public var y:Number;
		public var vector:NumPoint;
		public var scale:Number;
		public var alpha:Number;
		
		public var pulse:Number;
		public var pulseState:int;
		
		public function PowerUp(game:GameScene)
		{
			this.game = game;
			vector = new NumPoint(0, 0);
		}
		
		public function init(x:Number, y:Number, vector:NumPoint):void {
			active = true;
			fading = false;
			this.x = x;
			this.y = y;
			this.vector.x = vector.x;
			this.vector.y = vector.y;
			pulse = 0;
			pulseState = 0;
			scale = 1;
			alpha = 1;
		}
		
		public function deInit():void {
			
		}
		
		public function update(dt:Number):void {
			vector.x *= 0.99;
			vector.y *= 0.99;
			this.x += vector.x;
			this.y += vector.y;
			
			if(pulseState == 0) {
				pulse += dt*2;
				if(pulse >= 1) {
					pulse = 1;
					pulseState = 1;
				}
			} else {
				pulse -= dt*2;
				if(pulse <= 0) {
					pulse = 0;
					pulseState = 0;
				}
			}
			
			if(fading) {
				scale += dt*16;
				alpha -= dt*5;
				if(alpha <= 0) {
					active = false;
				}
				return;
			}
			
			var dx:Number = game.hero.x - x;
			var dy:Number = game.hero.y - y;
			var dist:Number = Math.sqrt(dx*dx + dy*dy);
			if(dist < 60) {
				game.addTime();
				fading = true;
			}
		}
	}
}