package Game
{
	import starling.display.Image;

	public class Projectile
	{
		public var game:GameScene;
		public var active:Boolean;
		public var lifespan:Number;
		public var speed:Number;
		public var team:int;
		public var dx:Number;
		public var dy:Number;
		
		public var image:Image;
		
		public function Projectile(game:GameScene)
		{
			this.game = game;
			image = new Image(Root.assets.getTexture("bullet"));
			image.pivotX = image.width*0.5;
			image.pivotY = image.height*0.5;
			image.scaleX = image.scaleY = 0.5;
			image.blendMode = "add";
			
			speed = 1000;
		}
		
		public function init(x:Number, y:Number, vector:NumPoint, rotation:Number, team:int, color:uint):void {
			dx = vector.x + Math.cos(rotation)*2000;
			dy = vector.y + Math.sin(rotation)*2000;
			image.x = x;
			image.y = y;
			image.rotation = rotation;
			image.color = color;
			image.alpha = 1;
			lifespan = 1;
			//game.particleLayer.addChild(image);
			this.team = team;
			active = true;
		}
		
		public function deInit():void {
			//game.particleLayer.removeChild(image);
		}
		
		public function update(dt:Number):void {
			image.x += dx*dt;
			image.y += dy*dt;
			
			if(team == 0) {
				var l:int = game.ships.length;
				for(var i:int = 0; i < l; i++) {
					var ship:Ship = game.ships[i];
					var dx:Number = ship.x - image.x;
					var dy:Number = ship.y - image.y;
					var dist:Number = Math.sqrt(dx*dx + dy*dy);
					if(dist < 30) {
						ship.hit();
						game.addHitParticles(image.x+dx*dt, image.y+dy*dt, image.color);
						active = false;
					}
				}
			} else {
				dx = game.hero.x - image.x;
				dy = game.hero.y - image.y;
				dist = Math.sqrt(dx*dx + dy*dy);
				if(dist < 30) {
					game.hero.hit();
					game.addHitParticles(image.x+dx*dt, image.y+dy*dt, image.color);
					active = false;
				}
			}
			
			if(lifespan > 0) lifespan -= dt*2;
			else {
				image.alpha -= dt*4;
				if(image.alpha <= 0) active = false;
			}
		}
	}
}